// BelegDoc.cpp : Implementierung der Klasse CBelegDoc
//
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "stdafx.h"
#include "Beleg.h"

#include "BelegDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CBelegDoc

IMPLEMENT_DYNCREATE(CBelegDoc, CDocument)

BEGIN_MESSAGE_MAP(CBelegDoc, CDocument)
	//{{AFX_MSG_MAP(CBelegDoc)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBelegDoc Konstruktion/Destruktion

CBelegDoc::CBelegDoc()
{
	// ZU ERLEDIGEN: Hier Code fr One-Time-Konstruktion einfgen
}

CBelegDoc::~CBelegDoc()
{
}

BOOL CBelegDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// ZU ERLEDIGEN: Hier Code zur Reinitialisierung einfgen
	// (SDI-Dokumente verwenden dieses Dokument)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CBelegDoc Serialisierung

void CBelegDoc::Serialize(CArchive& ar)
{
	try
	{
		m_ArrayLokal_Koord.Serialize(ar);
		m_ArrayKreise.Serialize(ar);
		m_ArrayRechtecke.Serialize(ar);
		m_ArrayDreiecke.Serialize(ar);
		m_ArrayKreissegmente.Serialize(ar);
	}
	catch(CException* e)
	{
		e->Delete();
		if (ar.IsStoring())
		{
			AfxMessageBox("Die Daten konnten nicht gespeichert werden!");
			loescheDaten();	
		}
		else
			AfxMessageBox("Die Daten konnten nicht gespeichert werden!");
	}	
}

/////////////////////////////////////////////////////////////////////////////
// CBelegDoc Diagnose

#ifdef _DEBUG
void CBelegDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBelegDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBelegDoc Befehle

void CBelegDoc::insert(Lokal_Koord * p_add)
{
	m_ArrayLokal_Koord.Add(p_add);
	SetModifiedFlag();
}

void CBelegDoc::insert(Kreis * p_add)
{
	m_ArrayKreise.Add(p_add);
	SetModifiedFlag();
}

void CBelegDoc::insert(Rechteck * p_add)
{
	m_ArrayRechtecke.Add(p_add);
	SetModifiedFlag();
}

void CBelegDoc::insert(Dreieck * p_add)
{
	m_ArrayDreiecke.Add(p_add);
	SetModifiedFlag();
}

void CBelegDoc::insert(Kreissegment * p_add)
{
	m_ArrayKreissegmente.Add(p_add);
	SetModifiedFlag();
}

CArray<Lokal_Koord*, Lokal_Koord*>* CBelegDoc::getArrayLokal_Koord()
{
	return &m_ArrayLokal_Koord;
}

CArray<Kreis*, Kreis*>* CBelegDoc::getArrayKreise()
{
	return &m_ArrayKreise;
}

CArray<Rechteck*, Rechteck*>* CBelegDoc::getArrayRechtecke()
{
	return &m_ArrayRechtecke;
}

CArray<Dreieck*, Dreieck*>* CBelegDoc::getArrayDreiecke()
{
	return &m_ArrayDreiecke;
}

CArray<Kreissegment*, Kreissegment*>* CBelegDoc::getArrayKreissegmente()
{
	return &m_ArrayKreissegmente;
}

void CBelegDoc::update()
{
	SetModifiedFlag();
}

void CBelegDoc::DeleteContents() 
{
	// Dokument leeren (bei SDI wird dadurch in View OnInitialUpdate() aufgerufen!)
	loescheDaten();

	CDocument::DeleteContents();
}

void CBelegDoc::loescheDaten() 
{
	// Dokument leeren (bei SDI wird dadurch in View OnInitialUpdate() aufgerufen!)
	for(int i = 0; i < m_ArrayLokal_Koord.GetSize(); i++)
		delete m_ArrayLokal_Koord.GetAt(i);

	m_ArrayLokal_Koord.RemoveAll();

	for(i = 0; i < m_ArrayKreise.GetSize(); i++)
		delete m_ArrayKreise.GetAt(i);

	m_ArrayKreise.RemoveAll();

	for(i = 0; i < m_ArrayRechtecke.GetSize(); i++)
		delete m_ArrayRechtecke.GetAt(i);

	m_ArrayRechtecke.RemoveAll();

	for(i = 0; i < m_ArrayDreiecke.GetSize(); i++)
		delete m_ArrayDreiecke.GetAt(i);

	m_ArrayDreiecke.RemoveAll();

	for(i = 0; i < m_ArrayKreissegmente.GetSize(); i++)
		delete m_ArrayKreissegmente.GetAt(i);

	m_ArrayKreissegmente.RemoveAll();
}

void CBelegDoc::remove(Lokal_Koord * f)
{
	for(int i = 0; i < m_ArrayLokal_Koord.GetSize(); i++)
	{
		if(f == m_ArrayLokal_Koord.GetAt(i))
		{
			// zuerst Verkufer kndigen
			for(int z =  f->GetKreis()->GetSize() - 1 ; z >= 0; z--)
			{
				f->GetKreis()->GetAt(z)->SetLokal_Koord(NULL);
			}
			
			for(z =  f->GetRechteck()->GetSize() - 1 ; z >= 0; z--)
			{
				f->GetRechteck()->GetAt(z)->SetLokal_Koord(NULL);
			}

			for(z =  f->GetDreieck()->GetSize() - 1 ; z >= 0; z--)
			{
				f->GetDreieck()->GetAt(z)->SetLokal_Koord(NULL);
			}
			
			for(z =  f->GetKreissegment()->GetSize() - 1 ; z >= 0; z--)
			{
				f->GetKreissegment()->GetAt(z)->SetLokal_Koord(NULL);
			}

			delete f;
			m_ArrayLokal_Koord.RemoveAt(i);
			SetModifiedFlag();
			break;
		}
	}
}

void CBelegDoc::remove(Kreis* v)
{
	for(int i = 0; i < m_ArrayLokal_Koord.GetSize(); i++)
	{
		if(v == m_ArrayKreise.GetAt(i))
		{
			// zuerst Firma kndigen
			if(v->GetLokal_Koord())
				v->GetLokal_Koord()->entfernen(v);
		
			delete v;
			m_ArrayLokal_Koord.RemoveAt(i);
			SetModifiedFlag();
			break;
		}
	}
}

void CBelegDoc::remove(Rechteck* r)
{
	for(int i = 0; i < m_ArrayLokal_Koord.GetSize(); i++)
	{
		if(r == m_ArrayRechtecke.GetAt(i))
		{
			// zuerst Firma kndigen
			if(r->GetLokal_Koord())
				r->GetLokal_Koord()->entfernen(r);
		
			delete r;
			m_ArrayLokal_Koord.RemoveAt(i);
			SetModifiedFlag();
			break;
		}
	}
}

void CBelegDoc::remove(Dreieck* r)
{
	for(int i = 0; i < m_ArrayLokal_Koord.GetSize(); i++)
	{
		if(r == m_ArrayDreiecke.GetAt(i))
		{
			// zuerst Firma kndigen
			if(r->GetLokal_Koord())
				r->GetLokal_Koord()->entfernen(r);
		
			delete r;
			m_ArrayLokal_Koord.RemoveAt(i);
			SetModifiedFlag();
			break;
		}
	}
}

void CBelegDoc::remove(Kreissegment* v)
{
	for(int i = 0; i < m_ArrayLokal_Koord.GetSize(); i++)
	{
		if(v == m_ArrayKreissegmente.GetAt(i))
		{
			// zuerst Firma kndigen
			if(v->GetLokal_Koord())
				v->GetLokal_Koord()->entfernen(v);
		
			delete v;
			m_ArrayLokal_Koord.RemoveAt(i);
			SetModifiedFlag();
			break;
		}
	}
}