// BelegView.cpp : Implementierung der Klasse CBelegView
//

#include "stdafx.h"
#include "Beleg.h"

#include "BelegDoc.h"
#include "BelegView.h"

#include "DialogAuswahlLokalKoord.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBelegView

IMPLEMENT_DYNCREATE(CBelegView, CFormView)

BEGIN_MESSAGE_MAP(CBelegView, CFormView)
	//{{AFX_MSG_MAP(CBelegView)
	ON_BN_CLICKED(IDC_BUTTON_AUSWAHL, OnButtonAuswahl)
	ON_BN_CLICKED(IDC_BUTTON_LOESCHEN, OnButtonLoeschen)
	ON_BN_CLICKED(IDC_BUTTON_NEU, OnButtonNeu)
	ON_BN_CLICKED(IDC_BUTTON_SPEICHERN, OnButtonSpeichern)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_ELEMENTE, OnDblclkListElemente)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_RECHTECKE, OnDblclkListRechtecke)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_DREIECKE, OnDblclkListDreiecke)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_KREISSEGMENTE, OnDblclkListKreissegmente)
	//}}AFX_MSG_MAP
	// Standard-Druckbefehle
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBelegView Konstruktion/Destruktion

CBelegView::CBelegView()
	: CFormView(CBelegView::IDD)
{
	//{{AFX_DATA_INIT(CBelegView)
	m_Name = _T("");
	m_X = 0.0;
	m_Y = 0.0;
	m_Winkel = 0.0;
	m_Flaeche = _T("0");
	m_SY = _T("0");
	m_SX = _T("0");
	m_GlobSX = _T("");
	m_GlobSY = _T("");
	m_GlobFlaeche = _T("");
	//}}AFX_DATA_INIT
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen,

}

CBelegView::~CBelegView()
{
}

void CBelegView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBelegView)
	DDX_Control(pDX, IDC_LIST_KREISSEGMENTE, m_KreissegmentListe);
	DDX_Control(pDX, IDC_LIST_DREIECKE, m_DreieckListe);
	DDX_Control(pDX, IDC_LIST_RECHTECKE, m_RechteckListe);
	DDX_Control(pDX, IDC_LIST_ELEMENTE, m_KreisListe);
	DDX_Text(pDX, IDC_EDIT_NAME, m_Name);
	DDX_Text(pDX, IDC_EDIT_X, m_X);
	DDX_Text(pDX, IDC_EDIT_Y, m_Y);
	DDX_Text(pDX, IDC_EDIT_WINKEL, m_Winkel);
	DDV_MinMaxDouble(pDX, m_Winkel, -360., 360.);
	DDX_Text(pDX, IDC_EDIT_FLAECHE, m_Flaeche);
	DDX_Text(pDX, IDC_EDIT_SY, m_SY);
	DDX_Text(pDX, IDC_EDIT_SX, m_SX);
	DDX_Text(pDX, IDC_EDIT_GSX, m_GlobSX);
	DDX_Text(pDX, IDC_EDIT_GSY, m_GlobSY);
	DDX_Text(pDX, IDC_EDIT_GFLAECHE, m_GlobFlaeche);
	//}}AFX_DATA_MAP
}

BOOL CBelegView::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBelegView Drucken

BOOL CBelegView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}

void CBelegView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// ZU ERLEDIGEN: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

void CBelegView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// ZU ERLEDIGEN: Hier Bereinigungsarbeiten nach dem Drucken einfgen
}

void CBelegView::OnPrint(CDC* pDC, CPrintInfo*)
{
	// ZU ERLEDIGEN: Code zum Ausdrucken der Steuerelemente einfgen
}

/////////////////////////////////////////////////////////////////////////////
// CBelegView Diagnose

#ifdef _DEBUG
void CBelegView::AssertValid() const
{
	CFormView::AssertValid();
}

void CBelegView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CBelegDoc* CBelegView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBelegDoc)));
	return (CBelegDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBelegView Nachrichten-Handler

void CBelegView::OnButtonAuswahl() 
{
	DialogAuswahlLokalKoord dlg;
	
	dlg.setArrayLokal_Koord(GetDocument()->getArrayLokal_Koord());
	
	if(dlg.DoModal() == IDOK)
	{
		subjekt = dlg.getSelLokal_Koord();
		neuesSubjekt = FALSE;
		setzeSubjektInView();
	}
}

void CBelegView::OnButtonLoeschen() 
{
	if(!neuesSubjekt)
	{
		GetDocument()->UpdateAllViews(this, 1L, (CObject*)subjekt);
		GetDocument()->remove(subjekt);
		OnButtonNeu();
	}	
}

void CBelegView::OnButtonNeu() 
{
	if(!neuesSubjekt)
	{
		subjekt = new Lokal_Koord;;
		neuesSubjekt = TRUE;
		setzeSubjektInView();
	}
}

void CBelegView::OnButtonSpeichern() 
{
		if(subjekt)
	{
		leseSubjektAusView();
		if(neuesSubjekt)
		{
			GetDocument()->insert(subjekt);
			neuesSubjekt = FALSE;
		}
		else
			GetDocument()->update();
	
		GetDocument()->UpdateAllViews(this, 0L, (CObject*)subjekt);
	}
}

void CBelegView::leseSubjektAusView()
{
	if(subjekt)
	{
		UpdateData(TRUE);
		subjekt->SetName(m_Name);
		subjekt->setX(m_X);
		subjekt->setY(m_Y);
		subjekt->setWinkel(m_Winkel);
	}
}

void CBelegView::setzeGlobalDaten()
{
	double	glob_Fl_Moment_x	= 0;
	double	glob_Fl_Moment_y	= 0;
	double  glob_Flaeche		= 0;

	for (int i=0; i < GetDocument()->getArrayLokal_Koord()->GetSize(); i++)
	{
		Lokal_Koord* koordzaehler;
		koordzaehler = GetDocument()->getArrayLokal_Koord()->GetAt(i);

		glob_Fl_Moment_x += (koordzaehler->getglobalSx() * koordzaehler->getFlaeche());
		glob_Fl_Moment_y += (koordzaehler->getglobalSy() * koordzaehler->getFlaeche());
		glob_Flaeche	 += koordzaehler->getFlaeche();
	}

	if ( glob_Flaeche > 0)
	{
		m_GlobSX.Format("%.2f", glob_Fl_Moment_y / glob_Flaeche );
		m_GlobSY.Format("%.2f", glob_Fl_Moment_x / glob_Flaeche );
		m_GlobFlaeche.Format("%.2f",  glob_Flaeche ); 
	}
	UpdateData(FALSE);
}

void CBelegView::setzeSubjektInView()
{
	if(subjekt)
	{
		m_Name	= subjekt->GetName();
		m_X		= subjekt->getX();
		m_Y		= subjekt->getY();
		m_Winkel = subjekt->getWinkel();

		// Kreisliste leeren
		m_KreisListe.DeleteAllItems();
		
		const CArray<Kreis*, Kreis*>* arrKreise;
		arrKreise = subjekt->GetKreis();
		// alle Kreise laden und in Liste stellen
		for(int i = 0; i < arrKreise->GetSize(); i++)
		{
			const Kreis* kreis;
			kreis = arrKreise->GetAt(i);

			CString x1, y1, radius;
			
			x1.Format("%.2f", kreis->GetX1());
			y1.Format("%.2f", kreis->GetY1());
			radius.Format("%.2f", kreis->GetRadius());
			
			int pos = m_KreisListe.InsertItem(i, kreis->GetName(),0);
			m_KreisListe.SetItem(pos, 1, LVIF_TEXT, x1, 0, 0, 0, 0);
			m_KreisListe.SetItem(pos, 2, LVIF_TEXT, y1, 0, 0, 0, 0);
			m_KreisListe.SetItem(pos, 3, LVIF_TEXT, radius, 0, 0, 0, 0);

			m_KreisListe.SetItemData(pos, (DWORD)kreis);
		}

		// Rechteckliste leeren
		m_RechteckListe.DeleteAllItems();
		
		const CArray<Rechteck*, Rechteck*>* arrRechtecke;
		arrRechtecke = subjekt->GetRechteck();
		// alle Rechtecke laden und in Liste stellen
		for( i = 0; i < arrRechtecke->GetSize(); i++)
		{
			const Rechteck* rechteck;
			rechteck = arrRechtecke->GetAt(i);

			CString x1, y1, x2, y2;
			
			x1.Format("%.2f", rechteck->GetX1());
			y1.Format("%.2f", rechteck->GetY1());
			x2.Format("%.2f", rechteck->GetX2());
			y2.Format("%.2f", rechteck->GetY2());
					
			int pos = m_RechteckListe.InsertItem(i, rechteck->GetName(),3);
			m_RechteckListe.SetItem(pos, 1, LVIF_TEXT, x1, 0, 0, 0, 0);
			m_RechteckListe.SetItem(pos, 2, LVIF_TEXT, y1, 0, 0, 0, 0);
			m_RechteckListe.SetItem(pos, 3, LVIF_TEXT, x2, 0, 0, 0, 0);
			m_RechteckListe.SetItem(pos, 4, LVIF_TEXT, y2, 0, 0, 0, 0);

			m_RechteckListe.SetItemData(pos, (DWORD)rechteck);
		}

		// Dreieckliste leeren
		m_DreieckListe.DeleteAllItems();
		
		const CArray<Dreieck*, Dreieck*>* arrDreiecke;
		arrDreiecke = subjekt->GetDreieck();
		// alle Dreiecke laden und in Liste stellen
		for( i = 0; i < arrDreiecke->GetSize(); i++)
		{
			const Dreieck* dreieck;
			dreieck = arrDreiecke->GetAt(i);

			CString x1, y1, x2, y2, x3, y3;
			
			x1.Format("%.2f", dreieck->GetX1());
			y1.Format("%.2f", dreieck->GetY1());
			x2.Format("%.2f", dreieck->GetX2());
			y2.Format("%.2f", dreieck->GetY2());
			x3.Format("%.2f", dreieck->GetX3());
			y3.Format("%.2f", dreieck->GetY3());

			int pos = m_DreieckListe.InsertItem(i, dreieck->GetName(),2);
			m_DreieckListe.SetItem(pos, 1, LVIF_TEXT, x1, 0, 0, 0, 0);
			m_DreieckListe.SetItem(pos, 2, LVIF_TEXT, y1, 0, 0, 0, 0);
			m_DreieckListe.SetItem(pos, 3, LVIF_TEXT, x2, 0, 0, 0, 0);
			m_DreieckListe.SetItem(pos, 4, LVIF_TEXT, y2, 0, 0, 0, 0);
			m_DreieckListe.SetItem(pos, 5, LVIF_TEXT, x3, 0, 0, 0, 0);
			m_DreieckListe.SetItem(pos, 6, LVIF_TEXT, y3, 0, 0, 0, 0);

			m_DreieckListe.SetItemData(pos, (DWORD)dreieck);
		}

		// Kreissegmentliste leeren
		m_KreissegmentListe.DeleteAllItems();
		
		const CArray<Kreissegment*, Kreissegment*>* arrKreissegmente;
		arrKreissegmente = subjekt->GetKreissegment();
		// alle Kreissegmente laden und in Liste stellen
		for(i = 0; i < arrKreissegmente->GetSize(); i++)
		{
			const Kreissegment* kreissegment;
			kreissegment = arrKreissegmente->GetAt(i);

			CString x1, y1, radius, oewinkel, lwinkel;
			
			x1.Format("%.2f", kreissegment->GetX1());
			y1.Format("%.2f", kreissegment->GetY1());
			radius.Format("%.2f", kreissegment->GetRadius());
			oewinkel.Format("%.2f", kreissegment->GetOeWinkel());
			lwinkel.Format("%.2f", kreissegment->GetLWinkel());
						
			int pos = m_KreissegmentListe.InsertItem(i, kreissegment->GetName(),1);
			m_KreissegmentListe.SetItem(pos, 1, LVIF_TEXT, x1, 0, 0, 0, 0);
			m_KreissegmentListe.SetItem(pos, 2, LVIF_TEXT, y1, 0, 0, 0, 0);
			m_KreissegmentListe.SetItem(pos, 3, LVIF_TEXT, radius, 0, 0, 0, 0);
			m_KreissegmentListe.SetItem(pos, 4, LVIF_TEXT, oewinkel, 0, 0, 0, 0);
			m_KreissegmentListe.SetItem(pos, 5, LVIF_TEXT, lwinkel, 0, 0, 0, 0);

			m_KreissegmentListe.SetItemData(pos, (DWORD)kreissegment);
		}
		m_SX.Format("%.3f" , subjekt->getlokalSx());
		m_SY.Format("%.3f" , subjekt->getlokalSy());
		m_Flaeche.Format("%.3f", subjekt->getFlaeche());

		setzeGlobalDaten();
		
		UpdateData(FALSE);
	}
}

void CBelegView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	GetParentFrame()->RecalcLayout();
	ResizeParentToFit(FALSE);
	
	m_symboleKlein.Create(16,16,TRUE, 4,4);
	m_symboleKlein.Add(AfxGetApp()->LoadIcon(IDI_ICON_KREIS));
	m_symboleKlein.Add(AfxGetApp()->LoadIcon(IDI_ICON_KREISSEG));
	m_symboleKlein.Add(AfxGetApp()->LoadIcon(IDI_ICON_DREIECK));
	m_symboleKlein.Add(AfxGetApp()->LoadIcon(IDI_ICON_RECHTECK));

	m_KreisListe.InsertColumn(0, "Name", LVCFMT_LEFT,  80);
	m_KreisListe.InsertColumn(1, "X1", LVCFMT_LEFT,  70);
	m_KreisListe.InsertColumn(2, "Y1", LVCFMT_LEFT,  70);
	m_KreisListe.InsertColumn(3, "Radius", LVCFMT_LEFT,  70);
	m_KreisListe.SetImageList(&m_symboleKlein, LVSIL_SMALL);


	m_RechteckListe.InsertColumn(0, "Name", LVCFMT_LEFT,  70);
	m_RechteckListe.InsertColumn(1, "X1", LVCFMT_LEFT,  55);
	m_RechteckListe.InsertColumn(2, "Y1", LVCFMT_LEFT,  55);
	m_RechteckListe.InsertColumn(3, "X2", LVCFMT_LEFT,  55);
	m_RechteckListe.InsertColumn(4, "Y2", LVCFMT_LEFT,  55);
	m_RechteckListe.SetImageList(&m_symboleKlein, LVSIL_SMALL);

	m_DreieckListe.InsertColumn(0, "Name", LVCFMT_LEFT,  60);
	m_DreieckListe.InsertColumn(1, "X1", LVCFMT_LEFT,  50);
	m_DreieckListe.InsertColumn(2, "Y1", LVCFMT_LEFT,  50);
	m_DreieckListe.InsertColumn(3, "X2", LVCFMT_LEFT,  50);
	m_DreieckListe.InsertColumn(4, "Y2", LVCFMT_LEFT,  50);
	m_DreieckListe.InsertColumn(5, "X3", LVCFMT_LEFT,  50);
	m_DreieckListe.InsertColumn(6, "Y3", LVCFMT_LEFT,  50);
	m_DreieckListe.SetImageList(&m_symboleKlein, LVSIL_SMALL);

	m_KreissegmentListe.InsertColumn(0, "Name", LVCFMT_LEFT,  60);
	m_KreissegmentListe.InsertColumn(1, "X1", LVCFMT_LEFT,  50);
	m_KreissegmentListe.InsertColumn(2, "Y1", LVCFMT_LEFT,  50);
	m_KreissegmentListe.InsertColumn(3, "Radius", LVCFMT_LEFT,  50);
	m_KreissegmentListe.InsertColumn(4, "ffnungswinkel", LVCFMT_LEFT,  70);
	m_KreissegmentListe.InsertColumn(5, "Lagewinkel", LVCFMT_LEFT,  70);
	m_KreissegmentListe.SetImageList(&m_symboleKlein, LVSIL_SMALL);


	if(GetDocument()->getArrayLokal_Koord()->GetSize() < 1)
	{	// keine Firma im Array
		subjekt = new Lokal_Koord;
		neuesSubjekt = TRUE;
	}
	else
	{	// erste Firma als Subjekt
		subjekt = GetDocument()->getArrayLokal_Koord()->GetAt(0);
		neuesSubjekt = FALSE;
	}
	setzeSubjektInView();
	setzeGlobalDaten();
}

void CBelegView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if(pHint && subjekt)
	{
		if((CObject*)subjekt == pHint)
		{
			setzeSubjektInView();
			setzeGlobalDaten();
			return;
		}
		
		Kreis* k = static_cast<Kreis*>(pHint);
		if(k)
			setzeSubjektInView();
			
		Rechteck* r = static_cast<Rechteck*>(pHint);
		if(r)
			setzeSubjektInView();
					
		Dreieck* d = static_cast<Dreieck*>(pHint);
		if(r)
			setzeSubjektInView();
		
		Kreissegment* ks = static_cast<Kreissegment*>(pHint);
		if(ks)
			setzeSubjektInView();
	}
}


void CBelegView::OnDblclkListElemente(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int selItem = m_KreisListe.GetNextItem(-1, LVNI_SELECTED);
	if(selItem != -1)
	{
		Kreis* selKreis = (Kreis*)m_KreisListe.GetItemData(selItem);
		App()->zeigeKreisInView(selKreis);
	}

	*pResult = 0;   
}

void CBelegView::OnEditLokalKoord() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	
}

void CBelegView::OnDblclkListRechtecke(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int selItem = m_RechteckListe.GetNextItem(-1, LVNI_SELECTED);
	if(selItem != -1)
	{
		Rechteck* selRechteck = (Rechteck*)m_RechteckListe.GetItemData(selItem);
		App()->zeigeRechteckInView(selRechteck);
	}
	*pResult = 0;
}

void CBelegView::OnDblclkListDreiecke(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int selItem = m_DreieckListe.GetNextItem(-1, LVNI_SELECTED);
	if(selItem != -1)
	{
		Dreieck* selDreieck = (Dreieck*)m_DreieckListe.GetItemData(selItem);
		App()->zeigeDreieckInView(selDreieck);
	}
	*pResult = 0;
}

void CBelegView::OnDblclkListKreissegmente(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int selItem = m_KreissegmentListe.GetNextItem(-1, LVNI_SELECTED);
	if(selItem != -1)
	{
		Kreissegment* selKreissegment = (Kreissegment*)m_KreissegmentListe.GetItemData(selItem);
		App()->zeigeKreissegmentInView(selKreissegment);
	}
	*pResult = 0;
}
