// Dreieck.cpp: Implementierung der Klasse Dreieck.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Beleg.h"
#include "Dreieck.h"
#include "Lokal_Koord.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_SERIAL(Dreieck, element, 1)


//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

Dreieck::Dreieck():element()
{
	m_X2 = 0;
	m_Y2 = 0;

	m_X3 = 0;
	m_Y3 = 0;
}

void Dreieck::SetX2(double x2)
	{m_X2 = x2;}

double Dreieck::GetX2() const
	{return m_X2;}

void Dreieck::SetY2(double y2)
	{m_Y2 = y2;}

double Dreieck::GetY2() const
	{return m_Y2;}

void Dreieck::SetX3(double x3)
	{m_X3 = x3;}

double Dreieck::GetX3() const
	{return m_X3;}

void Dreieck::SetY3(double y3)
	{m_Y3 = y3;}

double Dreieck::GetY3() const
	{return m_Y3;}

void Dreieck::SetLokal_Koord(Lokal_Koord* l)
{
	// erst aus altem lokalen System entfernen
	if(m_Lokal_Koord)
		m_Lokal_Koord->entfernen(this);

	if(l)
	{
		// in neues lokales Koordinatensysten einfgen
		l->einfuegen(this);
	}
	m_Lokal_Koord = l;
}

double Dreieck::GetFlaeche() const
{
	double A;
	A = abs((m_Y2 - m_Y1)*(m_X3 - m_X1))/2;
	return A;
}

double Dreieck::GetSx() const
{
	double Sx;
	Sx = m_X1 + (m_X2-m_X1)/3;
	return Sx;
}

double Dreieck::GetSy() const
{
	double Sy;
	Sy = m_Y1 + (m_Y2-m_Y1)/3;
	return Sy;
}

void Dreieck::Serialize( CArchive& archive )
{
    // Zuerst Vaterklasse seralisieren
    element::Serialize( archive );

    if( archive.IsStoring() )
    {
		archive << m_X2 << m_Y2 << m_X3 << m_Y3;
	}
	else
	{
    	archive >> m_X2 >> m_Y2 >> m_X3 >> m_Y3;
	}	
}