// Kreissegment.cpp: Implementierung der Klasse Kreissegment.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Beleg.h"
#include "Kreissegment.h"
#include "Lokal_Koord.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(Kreissegment, element, 1)

Kreissegment::Kreissegment()
{	
	m_Radius   = 1;
	m_OeWinkel = 0;	
	m_LWinkel  = 0;
}

void Kreissegment::SetRadius(double r)
	{m_Radius = r;}

double Kreissegment::GetRadius() const
	{return m_Radius;}

void Kreissegment::SetOeWinkel(double b)
	{m_OeWinkel = b;}

double Kreissegment::GetOeWinkel() const
	{return m_OeWinkel;}

void Kreissegment::SetLWinkel(double h)
	{m_LWinkel = h;}

double Kreissegment::GetLWinkel() const
	{return m_LWinkel;}

void Kreissegment::SetLokal_Koord(Lokal_Koord* l)
{
	// erst aus altem lokalen System entfernen
	if(m_Lokal_Koord)
		m_Lokal_Koord->entfernen(this);

	if(l)
	{
		// in neues lokales Koordinatensysten einfgen
		l->einfuegen(this);
	}
	m_Lokal_Koord = l;
}

double Kreissegment::GetFlaeche() const
{
	double A;
	A = m_OeWinkel/360*Pi*m_Radius*m_Radius;
	return A;
}

double Kreissegment::GetSx() const
{
	double Sx;
	Sx = m_X1 + 0.6002 * m_Radius * cos(m_LWinkel + m_OeWinkel/2);
	return Sx;
}

double Kreissegment::GetSy() const
{
	double Sy;
	Sy = m_X1 + 0.6002*m_Radius * sin(m_LWinkel+m_OeWinkel/2);
	return Sy;
}

void Kreissegment::Serialize( CArchive& archive )
{
    // Zuerst Vaterklasse seralisieren
    element::Serialize( archive );

    if( archive.IsStoring() )
    {
		archive << m_Radius << m_OeWinkel << m_LWinkel;
	}
	else
	{
    	archive >> m_Radius >> m_OeWinkel >> m_LWinkel;
	}	
}

