// KreissegmentView.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Beleg.h"

#include "BelegDoc.h"
#include "KreissegmentView.h"

#include "DialogAuswahlKreissegment.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// KreissegmentView

IMPLEMENT_DYNCREATE(KreissegmentView, CFormView)

KreissegmentView::KreissegmentView()
	: CFormView(KreissegmentView::IDD)
{
	//{{AFX_DATA_INIT(KreissegmentView)
	m_LWinkel = 0.0;
	m_Name = _T("");
	m_OeWinkel = 90.0;
	m_X1 = 0.0;
	m_Y1 = 0.0;
	m_Radius = 1.0;
	//}}AFX_DATA_INIT
}

KreissegmentView::~KreissegmentView()
{
}

void KreissegmentView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(KreissegmentView)
	DDX_Control(pDX, IDC_COMBO_KOORD, m_Lokal_Koord);
	DDX_Text(pDX, IDC_EDIT_LWINKEL, m_LWinkel);
	DDV_MinMaxDouble(pDX, m_LWinkel, -360., 360.);
	DDX_Text(pDX, IDC_EDIT_NAME, m_Name);
	DDX_Text(pDX, IDC_EDIT_OEWINKEL, m_OeWinkel);
	DDV_MinMaxDouble(pDX, m_OeWinkel, 90., 90.);
	DDX_Text(pDX, IDC_EDIT_X1, m_X1);
	DDX_Text(pDX, IDC_EDIT_Y1, m_Y1);
	DDX_Text(pDX, IDC_EDIT_RADIUS, m_Radius);
	DDV_MinMaxDouble(pDX, m_Radius, 1.e-004, 10000000000000.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(KreissegmentView, CFormView)
	//{{AFX_MSG_MAP(KreissegmentView)
	ON_BN_CLICKED(IDC_BUTTON_AUSWAHL, OnButtonAuswahl)
	ON_BN_CLICKED(IDC_BUTTON_LOESCHEN, OnButtonLoeschen)
	ON_BN_CLICKED(IDC_BUTTON_NEU, OnButtonNeu)
	ON_BN_CLICKED(IDC_BUTTON_SPEICHERN, OnButtonSpeichern)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Diagnose KreissegmentView

#ifdef _DEBUG
void KreissegmentView::AssertValid() const
{
	CFormView::AssertValid();
}

void KreissegmentView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CBelegDoc* KreissegmentView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBelegDoc)));
	return (CBelegDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten KreissegmentView 

void KreissegmentView::setzeSubjektInView()
{
	if(subjekt)
	{
		m_Name = subjekt->GetName();
		m_Radius = subjekt->GetRadius();
		m_X1 = subjekt->GetX1();
		m_Y1 = subjekt->GetY1();
		m_OeWinkel = subjekt->GetOeWinkel();
		m_LWinkel = subjekt->GetLWinkel();

		UpdateData(FALSE);
		
		if(subjekt->GetLokal_Koord())
		{
			for(int i = 0; i < m_Lokal_Koord.GetCount(); i++)
			{
				if(subjekt->GetLokal_Koord() == (Lokal_Koord*)m_Lokal_Koord.GetItemDataPtr(i))
				{
					m_Lokal_Koord.SetCurSel(i);
					break;
				}
			}
		}
		else
		{
			int zeile = m_Lokal_Koord.FindStringExact(-1, "kein Koord");
			m_Lokal_Koord.SetCurSel(zeile);
		}

	}
}

void KreissegmentView::leseSubjektAusView()
{
	if(subjekt)
	{
		UpdateData(TRUE);
		subjekt->SetName(m_Name);
		subjekt->SetRadius(m_Radius);
		subjekt->SetX1(m_X1);
		subjekt->SetY1(m_Y1);
		subjekt->SetOeWinkel(m_OeWinkel);
		subjekt->SetLWinkel(m_LWinkel);

		int zeile = m_Lokal_Koord.GetCurSel();
		Lokal_Koord* f= (Lokal_Koord*)m_Lokal_Koord.GetItemDataPtr(zeile);
		subjekt->SetLokal_Koord(f);
	}
}

void KreissegmentView::OnButtonAuswahl() 
{
	DialogAuswahlKreissegment dlg;
	
	dlg.setArrayKreissegmente(GetDocument()->getArrayKreissegmente());
	
	if(dlg.DoModal() == IDOK)
	{
		subjekt = dlg.getSelKreissegment();
		setzeSubjektInView();
	}	
}

void KreissegmentView::OnButtonLoeschen() 
{
	if(!neuesSubjekt)
	{
		GetDocument()->remove(subjekt);
		GetDocument()->UpdateAllViews(this, 1L, (CObject*)subjekt);
		OnButtonNeu();
	}
}	

void KreissegmentView::OnButtonNeu() 
{
	if(!neuesSubjekt)
	{
		subjekt = new Kreissegment;
		neuesSubjekt = TRUE;
		setzeSubjektInView();
	}	
}

void KreissegmentView::OnButtonSpeichern() 
{
	if(subjekt)
	{
		leseSubjektAusView();
		if(neuesSubjekt)
		{
			GetDocument()->insert(subjekt);
			neuesSubjekt = FALSE;
		}
		else
			GetDocument()->update();

		GetDocument()->UpdateAllViews(this, 0L, (CObject*)subjekt->GetLokal_Koord());
	}
}

void KreissegmentView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit(FALSE);

	// ComboBox mit Firmen fllen

	m_Lokal_Koord.ResetContent();
	int zeile = m_Lokal_Koord.AddString("kein Koord");
	m_Lokal_Koord.SetItemDataPtr(zeile, (void*)NULL);
	for(int i = 0; i < GetDocument()->getArrayLokal_Koord()->GetSize(); i++)
	{
		Lokal_Koord* f = GetDocument()->getArrayLokal_Koord()->GetAt(i);
		int zeile = m_Lokal_Koord.AddString(f->GetName() );
		m_Lokal_Koord.SetItemDataPtr(zeile, (void*)f);
	}
	
	if(GetDocument()->getArrayKreissegmente()->GetSize() < 1)
	{	// keine Verkufer im Array
		subjekt = new Kreissegment;
		neuesSubjekt = TRUE;
	}
	else
	{	// erste Firma als Subjekt
		subjekt = GetDocument()->getArrayKreissegmente()->GetAt(0);
		neuesSubjekt = FALSE;
	}
	setzeSubjektInView();		
}

void KreissegmentView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if(pHint && subjekt)
	{
		Lokal_Koord* f = static_cast<Lokal_Koord*>(pHint);
		if(f)
		{
			// Verkufer haben Firma in ComboBox m_firma
			int zeile = m_Lokal_Koord.GetCurSel();
			if(f == (Lokal_Koord*)m_Lokal_Koord.GetItemDataPtr(zeile) && lHint == 1L)
			{
				int zeile = m_Lokal_Koord.FindStringExact(-1, "kein Koord");
				m_Lokal_Koord.SetCurSel(zeile);
			}

			// alten Eintrag lschen
			for(int i = 0; i < m_Lokal_Koord.GetCount(); i++)
			{
				if((CObject*)m_Lokal_Koord.GetItemDataPtr(i) == pHint)
				{
					m_Lokal_Koord.DeleteString(i);
					break;
				}
			}
			// neuer Eintrag, wenn Hint auf 0
			if(lHint == 0L)
			{	
				int zeile = m_Lokal_Koord.AddString(f->GetName());
				m_Lokal_Koord.SetItemDataPtr(zeile, (void*)f);
			}
		}

		if((CObject*)subjekt == pHint)
			setzeSubjektInView();
	}
}

void KreissegmentView::setSubjekt(CObject * neuesKreissegment)
{
	Kreissegment* tmp = dynamic_cast<Kreissegment*>(neuesKreissegment);
	if(tmp)
		subjekt = tmp;
}

CObject* KreissegmentView::getSubjekt()
{
	return subjekt;
}