// Lokal_Koord.cpp: Implementierung der Klasse Lokal_Koord.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Beleg.h"
#include "Lokal_Koord.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_SERIAL(Lokal_Koord, CObject, 1)

Lokal_Koord::Lokal_Koord()
{
	m_Name		= "";
	m_X			= 0;
	m_Y			= 0;
	m_Winkel	= 0;
}

CString Lokal_Koord::GetName() const
	{return m_Name;}

void Lokal_Koord::SetName(const CString& n)
	{m_Name = n;}

double Lokal_Koord::getX() const
	{return m_X;}

void Lokal_Koord::setX(double x)
	{m_X = x;}

double Lokal_Koord::getY() const
	{return m_Y;}

void Lokal_Koord::setY(double y)
	{m_Y = y;}

double Lokal_Koord::getWinkel() const
	{return m_Winkel;}

void Lokal_Koord::setWinkel(double winkel)
	{m_Winkel = winkel;}

///////////////////////////////////////////////////////////////////////

const CArray<Kreis*, Kreis*>* Lokal_Koord::GetKreis() const
{
	return &m_ArrayKreise;
}

void Lokal_Koord::einfuegen(Kreis* kreis)
{
	// Kreis schon enthalten ?
	for(int i = 0; i < m_ArrayKreise.GetSize(); i++)
		if(m_ArrayKreise.GetAt(i) == kreis)
			return;

	m_ArrayKreise.Add(kreis);
}

void Lokal_Koord::entfernen(Kreis* kreis)
{
	for(int i=0 ; i < m_ArrayKreise.GetSize(); i++)
		if(m_ArrayKreise.GetAt(i) == kreis)
		{
			m_ArrayKreise.RemoveAt(i);
			break;
		}
}

//////////////////////////////////////////////////////////////////////

const CArray<Rechteck*, Rechteck*>* Lokal_Koord::GetRechteck() const
{
	return &m_ArrayRechtecke;
}

void Lokal_Koord::einfuegen(Rechteck* rechteck)
{
	// Rechteck schon enthalten ?
	for(int i = 0; i < m_ArrayRechtecke.GetSize(); i++)
		if(m_ArrayRechtecke.GetAt(i) == rechteck)
			return;

	m_ArrayRechtecke.Add(rechteck);
}

void Lokal_Koord::entfernen(Rechteck* rechteck)
{
	for(int i=0 ; i < m_ArrayRechtecke.GetSize(); i++)
		if(m_ArrayRechtecke.GetAt(i) == rechteck)
		{
			m_ArrayRechtecke.RemoveAt(i);
			break;
		}
}

///////////////////////////////////////////////////////////////////////

const CArray<Dreieck*, Dreieck*>* Lokal_Koord::GetDreieck() const
{
	return &m_ArrayDreiecke;
}

void Lokal_Koord::einfuegen(Dreieck* dreieck)
{
	// Dreieck schon enthalten ?
	for(int i = 0; i < m_ArrayDreiecke.GetSize(); i++)
		if(m_ArrayDreiecke.GetAt(i) == dreieck)
			return;

	m_ArrayDreiecke.Add(dreieck);
}

void Lokal_Koord::entfernen(Dreieck* dreieck)
{
	for(int i=0 ; i < m_ArrayDreiecke.GetSize(); i++)
		if(m_ArrayDreiecke.GetAt(i) == dreieck)
		{
			m_ArrayDreiecke.RemoveAt(i);
			break;
		}
}

/////////////////////////////////////////////////////////////
const CArray<Kreissegment*, Kreissegment*>* Lokal_Koord::GetKreissegment() const
{
	return &m_ArrayKreissegmente;
}

void Lokal_Koord::einfuegen(Kreissegment* kreissegment)
{
	// Kreis schon enthalten ?
	for(int i = 0; i < m_ArrayKreissegmente.GetSize(); i++)
		if(m_ArrayKreissegmente.GetAt(i) == kreissegment)
			return;

	m_ArrayKreissegmente.Add(kreissegment);
}

void Lokal_Koord::entfernen(Kreissegment* kreissegment)
{
	for(int i=0 ; i < m_ArrayKreissegmente.GetSize(); i++)
		if(m_ArrayKreissegmente.GetAt(i) == kreissegment)
		{
			m_ArrayKreissegmente.RemoveAt(i);
			break;
		}
}

////////////////////////////////////////////////////////////////
double Lokal_Koord::getFlaeche() const
{
	double flaeche=0;

	for (int i=0; i < m_ArrayKreise.GetSize(); i++)
	{
		const Kreis* kreiszaehler;
		kreiszaehler = m_ArrayKreise.GetAt(i);		
		flaeche += kreiszaehler->GetFlaeche();
	}

	for (i=0; i < m_ArrayRechtecke.GetSize(); i++)
	{
		const Rechteck* rechteckzaehler;
		rechteckzaehler = m_ArrayRechtecke.GetAt(i);		
		flaeche += rechteckzaehler->GetFlaeche();
	}

	for (i=0; i < m_ArrayDreiecke.GetSize(); i++)
	{
		const Dreieck* dreieckzaehler;
		dreieckzaehler = m_ArrayDreiecke.GetAt(i);		
		flaeche += dreieckzaehler->GetFlaeche();
	}

	for (i=0; i < m_ArrayKreissegmente.GetSize(); i++)
	{
		const Kreissegment* kreissegmentzaehler;
		kreissegmentzaehler = m_ArrayKreissegmente.GetAt(i);		
		flaeche += kreissegmentzaehler->GetFlaeche();
	}


	return flaeche;
}

double Lokal_Koord::getlokalSx() const
{
	double Sx = 0;

	for (int i=0; i < m_ArrayKreise.GetSize(); i++)
	{
		const Kreis* kreiszaehler;
		kreiszaehler = m_ArrayKreise.GetAt(i);		
		Sx += kreiszaehler->GetSx() * kreiszaehler->GetFlaeche();
	}
	
	for (i=0; i < m_ArrayRechtecke.GetSize(); i++)
	{
		const Rechteck* rechteckzaehler;
		rechteckzaehler = m_ArrayRechtecke.GetAt(i);		
		Sx += rechteckzaehler->GetSx() * rechteckzaehler->GetFlaeche();
	}

	for (i=0; i < m_ArrayDreiecke.GetSize(); i++)
	{
		const Dreieck* dreieckzaehler;
		dreieckzaehler = m_ArrayDreiecke.GetAt(i);		
		Sx += dreieckzaehler->GetSx() * dreieckzaehler->GetFlaeche();
	}

	for (i=0; i < m_ArrayKreissegmente.GetSize(); i++)
	{
		const Kreissegment* kreissegmentzaehler;
		kreissegmentzaehler = m_ArrayKreissegmente.GetAt(i);		
		Sx += kreissegmentzaehler->GetSx() * kreissegmentzaehler->GetFlaeche();
	}
	if ( getFlaeche() > 0 )
	{
		return (Sx / getFlaeche());
	}
	else return 0;
}

double Lokal_Koord::getlokalSy() const
{
	double Sy = 0;

	for (int i=0; i < m_ArrayKreise.GetSize(); i++)
	{
		const Kreis* kreiszaehler;
		kreiszaehler = m_ArrayKreise.GetAt(i);		
		Sy += kreiszaehler->GetSy() * kreiszaehler->GetFlaeche();
	}
	
	for (i=0; i < m_ArrayRechtecke.GetSize(); i++)
	{
		const Rechteck* rechteckzaehler;
		rechteckzaehler = m_ArrayRechtecke.GetAt(i);		
		Sy += rechteckzaehler->GetSy() * rechteckzaehler->GetFlaeche();
	}

	for (i=0; i < m_ArrayDreiecke.GetSize(); i++)
	{
		const Dreieck* dreieckzaehler;
		dreieckzaehler = m_ArrayDreiecke.GetAt(i);		
		Sy += dreieckzaehler->GetSy() * dreieckzaehler->GetFlaeche();
	}

	for (i=0; i < m_ArrayKreissegmente.GetSize(); i++)
	{
		const Kreissegment* kreissegmentzaehler;
		kreissegmentzaehler = m_ArrayKreissegmente.GetAt(i);		
		Sy += kreissegmentzaehler->GetSy() * kreissegmentzaehler->GetFlaeche();
	}
	if ( getFlaeche() > 0 )
	{
		return (Sy / getFlaeche());
	}
	else return 0;
}

double Lokal_Koord::getglobalSx() const
{
	double glSx;
	glSx = getlokalSx() * cos (m_Winkel) + m_X;
	return glSx;
}

double Lokal_Koord::getglobalSy() const
{
	double glSy;
	glSy = getlokalSy() * sin (m_Winkel) + m_Y;
	return glSy;
}

void Lokal_Koord::Serialize( CArchive& archive )
{
    // Zuerst Vaterklasse seralisieren
    CObject::Serialize( archive );

    if( archive.IsStoring() )
    {
		archive << m_Name << m_X << m_Y << m_Winkel;
	}	
    else
	{
        archive >> m_Name >> m_X >> m_Y >> m_Winkel;
	}
	m_ArrayKreise.Serialize(archive);
	m_ArrayRechtecke.Serialize(archive);
	m_ArrayDreiecke.Serialize(archive);
	m_ArrayKreissegmente.Serialize(archive);
}

