// Rechteck.cpp: Implementierung der Klasse Rechteck.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Beleg.h"
#include "Rechteck.h"
#include "Lokal_Koord.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_SERIAL(Rechteck, element, 1)
//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

Rechteck::Rechteck():element()
{
	m_X2 = 0;
	m_Y2 = 0;
}


void Rechteck::SetX2(double x)
	{m_X2 = x;}

double Rechteck::GetX2() const
	{return m_X2;}

void Rechteck::SetY2(double y)
	{m_Y2 = y;}

double Rechteck::GetY2() const
	{return m_Y2;}

void Rechteck::SetLokal_Koord(Lokal_Koord* l)
{
	// erst aus altem lokalen System entfernen
	if(m_Lokal_Koord)
		m_Lokal_Koord->entfernen(this);

	if(l)
	{
		// in neues lokales Koordinatensysten einfgen
		l->einfuegen(this);
	}
	m_Lokal_Koord = l;
}

double Rechteck::GetFlaeche() const
{
	double A;
	A =  abs((m_X2 - m_X1)*(m_Y2 - m_Y1));
	return A;
}

double Rechteck::GetSx() const
{
	double Sx;
	Sx = (m_X2+m_X1)/2;
	return Sx;
}

double Rechteck::GetSy() const
{
	double Sy;
	Sy = (m_Y2+m_Y1)/2;
	return Sy;
}

void Rechteck::Serialize( CArchive& archive )
{
    // Zuerst Vaterklasse seralisieren
    element::Serialize( archive );

    if( archive.IsStoring() )
    {
		archive << m_X2 << m_Y2;
	}
	else
	{
    	archive >> m_X2 >> m_Y2;
	}	
}
