// RechteckView.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Beleg.h"

#include "BelegDoc.h"
#include "RechteckView.h"

#include "DialogAuswahlRechteck.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// RechteckView

IMPLEMENT_DYNCREATE(RechteckView, CFormView)

RechteckView::RechteckView()
	: CFormView(RechteckView::IDD)
{
	//{{AFX_DATA_INIT(RechteckView)
	m_X1 = 0.0;
	m_X2 = 0.0;
	m_Y1 = 0.0;
	m_Y2 = 0.0;
	m_Name = _T("");
	//}}AFX_DATA_INIT
}

RechteckView::~RechteckView()
{
}

void RechteckView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(RechteckView)
	DDX_Control(pDX, IDC_COMBO_KOORD, m_Lokal_Koord);
	DDX_Text(pDX, IDC_EDIT_X1, m_X1);
	DDX_Text(pDX, IDC_EDIT_X2, m_X2);
	DDX_Text(pDX, IDC_EDIT_Y1, m_Y1);
	DDX_Text(pDX, IDC_EDIT_Y2, m_Y2);
	DDX_Text(pDX, IDC_EDIT_NAME, m_Name);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(RechteckView, CFormView)
	//{{AFX_MSG_MAP(RechteckView)
	ON_BN_CLICKED(IDC_BUTTON_AUSWAHL, OnButtonAuswahl)
	ON_BN_CLICKED(IDC_BUTTON_LOESCHEN, OnButtonLoeschen)
	ON_BN_CLICKED(IDC_BUTTON_NEU, OnButtonNeu)
	ON_BN_CLICKED(IDC_BUTTON_SPEICHERN, OnButtonSpeichern)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Diagnose RechteckView

#ifdef _DEBUG
void RechteckView::AssertValid() const
{
	CFormView::AssertValid();
}

void RechteckView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CBelegDoc* RechteckView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBelegDoc)));
	return (CBelegDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten RechteckView 
void RechteckView::setzeSubjektInView()
{
	if(subjekt)
	{
		m_Name = subjekt->GetName();
		m_X1 = subjekt->GetX1();
		m_Y1 = subjekt->GetY1();
		m_X2 = subjekt->GetX2();
		m_Y2 = subjekt->GetY2();
		UpdateData(FALSE);
		
		if(subjekt->GetLokal_Koord())
		{
			for(int i = 0; i < m_Lokal_Koord.GetCount(); i++)
			{
				if(subjekt->GetLokal_Koord() == (Lokal_Koord*)m_Lokal_Koord.GetItemDataPtr(i))
				{
					m_Lokal_Koord.SetCurSel(i);
					break;
				}
			}
		}
		else
		{
			int zeile = m_Lokal_Koord.FindStringExact(-1, "kein Koord");
			m_Lokal_Koord.SetCurSel(zeile);
		}

	}
}

void RechteckView::leseSubjektAusView()
{
	if(subjekt)
	{
		UpdateData(TRUE);
		subjekt->SetName(m_Name);
		subjekt->SetX1(m_X1);
		subjekt->SetY1(m_Y1);
		subjekt->SetX2(m_X2);
		subjekt->SetY2(m_Y2);

		int zeile = m_Lokal_Koord.GetCurSel();
		Lokal_Koord* f= (Lokal_Koord*)m_Lokal_Koord.GetItemDataPtr(zeile);
		subjekt->SetLokal_Koord(f);
	}
}

void RechteckView::OnButtonAuswahl() 
{
	DialogAuswahlRechteck dlg;
	
	dlg.setArrayRechtecke(GetDocument()->getArrayRechtecke());
	
	if(dlg.DoModal() == IDOK)
	{
		subjekt = dlg.getSelRechteck();
		setzeSubjektInView();
	}	
}

void RechteckView::OnButtonLoeschen() 
{
		if(!neuesSubjekt)
	{
		GetDocument()->remove(subjekt);
		GetDocument()->UpdateAllViews(this, 1L, (CObject*)subjekt);
		OnButtonNeu();
	}	
}

void RechteckView::OnButtonNeu() 
{
	if(!neuesSubjekt)
	{
		subjekt = new Rechteck;
		neuesSubjekt = TRUE;
		setzeSubjektInView();
	}		
}

void RechteckView::OnButtonSpeichern() 
{
	if(subjekt)
	{
		leseSubjektAusView();
		if(neuesSubjekt)
		{
			GetDocument()->insert(subjekt);
			neuesSubjekt = FALSE;
		}
		else
			GetDocument()->update();

		GetDocument()->UpdateAllViews(this, 0L, (CObject*)subjekt->GetLokal_Koord());
	}		
}

void RechteckView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit(FALSE);

	// ComboBox mit Firmen fllen

	m_Lokal_Koord.ResetContent();
	int zeile = m_Lokal_Koord.AddString("kein Koord");
	m_Lokal_Koord.SetItemDataPtr(zeile, (void*)NULL);
	for(int i = 0; i < GetDocument()->getArrayLokal_Koord()->GetSize(); i++)
	{
		Lokal_Koord* f = GetDocument()->getArrayLokal_Koord()->GetAt(i);
		int zeile = m_Lokal_Koord.AddString(f->GetName() );
		m_Lokal_Koord.SetItemDataPtr(zeile, (void*)f);
	}
	
	if(GetDocument()->getArrayRechtecke()->GetSize() < 1)
	{	// keine Verkufer im Array
		subjekt = new Rechteck;
		neuesSubjekt = TRUE;
	}
	else
	{	// erste Firma als Subjekt
		subjekt = GetDocument()->getArrayRechtecke()->GetAt(0);
		neuesSubjekt = FALSE;
	}
	setzeSubjektInView();		
}

void RechteckView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if(pHint && subjekt)
	{
		Lokal_Koord* f = static_cast<Lokal_Koord*>(pHint);
		if(f)
		{
			// Verkufer haben Firma in ComboBox m_firma
			int zeile = m_Lokal_Koord.GetCurSel();
			if(f == (Lokal_Koord*)m_Lokal_Koord.GetItemDataPtr(zeile) && lHint == 1L)
			{
				int zeile = m_Lokal_Koord.FindStringExact(-1, "kein Koord");
				m_Lokal_Koord.SetCurSel(zeile);
			}

			// alten Eintrag lschen
			for(int i = 0; i < m_Lokal_Koord.GetCount(); i++)
			{
				if((CObject*)m_Lokal_Koord.GetItemDataPtr(i) == pHint)
				{
					m_Lokal_Koord.DeleteString(i);
					break;
				}
			}
			// neuer Eintrag, wenn Hint auf 0
			if(lHint == 0L)
			{	
				int zeile = m_Lokal_Koord.AddString(f->GetName());
				m_Lokal_Koord.SetItemDataPtr(zeile, (void*)f);
			}
		}

		if((CObject*)subjekt == pHint)
			setzeSubjektInView();
	}
}

void RechteckView::setSubjekt(CObject * neuesRechteck)
{
	Rechteck* tmp = dynamic_cast<Rechteck*>(neuesRechteck);
	if(tmp)
		subjekt = tmp;
}

CObject* RechteckView::getSubjekt()
{
	return subjekt;
}
